HotLoot = LibStub("AceAddon-3.0"):NewAddon("HotLoot", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("HotLoot")
--==========================
--	       VAR LIST
--==========================
local lootedByHL, numLoot, vLoot
lootedByHL = {}
vLoot = {}
local icons = {}	
local lItems = ""
local closeEL = 0
local trigger = 0
iList = {}
eList = {}
--**************************
--==========================
--		MINIMAP ICON
--==========================
local hLDB = LibStub("LibDataBroker-1.1"):NewDataObject("HotLoot", {
	type = "launcher",
	icon = "Interface\\AddOns\\HotLoot\\icon",
	OnClick = function(clickedframe, button)
			LibStub("AceConfigDialog-3.0"):Open("HotLoot")
	end,
	OnTooltipShow = function(Tip)
		if not Tip or not Tip.AddLine then 
			return
		end
		Tip:AddLine("HotLoot", 1, 0.4, 0)
		Tip:AddLine(L["MMIconTT"], 1, 1, 1)
	end,
})
hIcon = LibStub("LibDBIcon-1.0")


--[[
function hIcon:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
	GameTooltip:ClearLines()
	hIcon.OnTooltipShow(GameTooltip)
	GameTooltip:Show()
end

function hIcon:OnLeave()
	GameTooltip:Hide()
end
]]
function HotLoot:createMainFrame()
	HotLoot.mainFrame = CreateFrame("Frame", "mainFrame", UIParent);
	HotLoot.mainFrame:SetHeight(16);
	HotLoot.mainFrame:SetPoint("CENTER", 0, 0);
	HotLoot.mainFrame:SetScript("OnUpdate", FadeItems);
	
	HotLoot.mainFrame.mainBG = HotLoot.mainFrame:CreateTexture("mainBG", "BACKGROUND");
	HotLoot.mainFrame.mainBG:SetAllPoints(HotLoot.mainFrame);
	HotLoot.mainFrame.mainBG:SetTexture(0.1, 0.1, 0.1, 0.7);
	
	HotLoot.mainFrame.anchorText = HotLoot.mainFrame:CreateFontString(nil, "OVERLAY");
	HotLoot.mainFrame.anchorText:SetPoint("CENTER", HotLoot.mainFrame, "CENTER", 0, 0);
	HotLoot.mainFrame.anchorText:SetFont(STANDARD_TEXT_FONT, 9, "NORMAL");
	--name:SetJustifyH("LEFT");
	HotLoot.mainFrame.anchorText:SetText("ANCHOR");
	HotLoot.mainFrame:SetWidth(HotLoot.mainFrame.anchorText:GetStringWidth() + 6);
	
	HotLoot.mainFrame:RegisterForDrag("LeftButton");
	HotLoot.mainFrame:SetMovable(true);
	HotLoot.mainFrame:EnableMouse(true);
	HotLoot.mainFrame:SetScript("OnDragStart", HotLoot.mainFrame.StartMoving);
	HotLoot.mainFrame:SetScript("OnDragStop", HotLoot.mainFrame.StopMovingOrSizing);
	HotLoot.mainFrame:Show();
end	

--******************ANNOUNCE FUNCTION********************

function Announce(input)
	if HotLoot:GetLootAnnounce() then
		print("|cFFCD6600HotLoot|r: " .. tostring(input));
	end
end

-- options select table


local themes = {
	["classic"] = {
		["name"] = "Classic",
		["src"] = nil,
		["showNames"] = true,
		["disNames"] = false,
		["showQuant"] = true,
		["inlineQuant"] = false,
		["iconSize"] = 24,
		["disIconSize"] = false,
		["alpha"] = 1
	},
	["frost"] = {
		["name"] = "Frost",
		["src"] = "FrostBG",
		["xOffset"] = -24,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = true,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	},
	["void"] = {
		["name"] = "Void",
		["src"] = "VoidBG",
		["xOffset"] = -24,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = true,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	},
	["cosmic"] = {
		["name"] = "Cosmic",
		["src"] = "CosmicBG",
		["xOffset"] = -24,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = false,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	},
	["cute"] = {
		["name"] = "Cute",
		["src"] = "CuteBG",
		["xOffset"] = -24,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = false,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	},
	["elvui"] = {
		["name"] = "ElvUI",
		["src"] = "ElvBG",
		["xOffset"] = -16,
		["showNames"] = true,
		["disNames"] = true,
		["showQuant"] = true,
		["inlineQuant"] = true,
		["iconSize"] = 16,
		["disIconSize"] = true,
		["alpha"] = 1
	}
}

local newThemes = {
	["classic"] ={
		["name"] = "Classic",
		["disIconSize"] = false,
		["height"] = 18,
		["bgFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\statusbars\\trans", 
		["edgeFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\borders\\trans", 
		["tile"] = true, ["tileSize"] = 16, ["edgeSize"] = 16, 
		["insets"] = { left = 2, right = 2, top = 2, bottom = 2 }
	},
	["minimal"] ={
		["name"] = "Minimal",
		["disIconSize"] = true,
		["height"] = 18,
		["bgFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\statusbars\\elv", 
		["edgeFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\borders\\px-black", 
		["tile"] = true, ["tileSize"] = 16, ["edgeSize"] = 16, 
		["insets"] = { left = 2, right = 2, top = 2, bottom = 2 }
	},
	["holo"] ={
		["name"] = "Holo",
		["disIconSize"] = true,
		["height"] = 18,
		["bgFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\statusbars\\holo", 
		["edgeFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\borders\\trans", 
		["tile"] = true, ["tileSize"] = 32, ["edgeSize"] = 16, 
		["insets"] = { left = 0, right = 0, top = 0, bottom = 0 }
	},
	["glow"] ={
		["name"] = "Glow",
		["disIconSize"] = true,
		["height"] = 22,
		["bgFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\statusbars\\glowbg", 
		["edgeFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\borders\\glowborder", 
		["tile"] = true, ["tileSize"] = 16, ["edgeSize"] = 16, 
		["insets"] = { left = 4, right = 4, top = 4, bottom = 4 }
	},
	["color"] ={
		["name"] = "Colored",
		["disIconSize"] = false,
		["height"] = 20,
		["bgFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\statusbars\\colorbg", 
		["edgeFile"] = "Interface\\AddOns\\HotLoot\\media\\textures\\borders\\colorborder", 
		["tile"] = true, ["tileSize"] = 16, ["edgeSize"] = 16, 
		["insets"] = { left = 2, right = 2, top = 2, bottom = 2 }
	},
}
local nameC,srcC,xOffsetC,showNamesC,disNamesC,heightC,showQuantC,inlineQuantC,iconSizeC,disIconSizeC,alphaC;
function LoadTheme(theme)
	-- load vars
	nameC = newThemes[theme]["name"]
	Announce("Loading theme: "..nameC)
	heightC = newThemes[theme]["height"]
	bgFileC = newThemes[theme]["bgFile"]
	edgeFileC = newThemes[theme]["edgeFile"]
	tileC = newThemes[theme]["tile"]
	tileSizeC = newThemes[theme]["tileSize"]
	edgeSizeC = newThemes[theme]["edgeSize"]
	insetsC = newThemes[theme]["insets"]
	disIconSizeC = newThemes[theme]["disIconSize"]
	--[[
	nameC = themes[theme]["name"];
	Announce("Loading theme: "..nameC);
	srcC = themes[theme]["src"];
	xOffsetC = themes[theme]["xOffset"];
	showNamesC = themes[theme]["showNames"];
	disNamesC = themes[theme]["disNames"];
	showQuantC = themes[theme]["showQuant"];
	inlineQuantC = themes[theme]["inlineQuant"];
	iconSizeC = themes[theme]["iconSize"];
	disIconSizeC = themes[theme]["disIconSize"];
	alphaC = themes[theme]["alpha"];

	HotLoot:SetLootShowNames(nil, showNamesC);
	HotLoot:SetLootShowQuantities(nil, showQuantC);
	HotLoot:SetInlineQuant(nil, inlineQuantC)
	HotLoot:SetLootIconSize(nil, iconSizeC);
	HotLoot:SetLootTrans(nil, alphaC);
	HotLoot:SetInlineQuant(nil, inlineQuantC);
	]]
end

function LoadThemeInit(theme)
	--newThemes
	-- load vars
	nameC = newThemes[theme]["name"]
	Announce("Loading theme: "..nameC)
	heightC = newThemes[theme]["height"]
	bgFileC = newThemes[theme]["bgFile"]
	edgeFileC = newThemes[theme]["edgeFile"]
	tileC = newThemes[theme]["tile"]
	tileSizeC = newThemes[theme]["tileSize"]
	edgeSizeC = newThemes[theme]["edgeSize"]
	insetsC = newThemes[theme]["insets"]
	disIconSizeC = newThemes[theme]["disIconSize"]
	--edgeFile = newThemes[theme]["xOffset"];
	--showNamesC = themes[theme]["showNames"];
	--disNamesC = themes[theme]["disNames"];
	--showQuantC = themes[theme]["showQuant"];
	--inlineQuantC = themes[theme]["inlineQuant"];
	--iconSizeC = themes[theme]["iconSize"];
	--disIconSizeC = themes[theme]["disIconSize"];
	--alphaC = themes[theme]["alpha"];
	--[[
	nameC = themes[theme]["name"];
	Announce("Loading theme: "..nameC);
	srcC = themes[theme]["src"];
	xOffsetC = themes[theme]["xOffset"];
	showNamesC = themes[theme]["showNames"];
	disNamesC = themes[theme]["disNames"];
	showQuantC = themes[theme]["showQuant"];
	inlineQuantC = themes[theme]["inlineQuant"];
	iconSizeC = themes[theme]["iconSize"];
	disIconSizeC = themes[theme]["disIconSize"];
	alphaC = themes[theme]["alpha"];
	]]
end
-- disNamesC
function HotLoot:ToggleNamesDisable()
	return disNamesC;
end
-- disIconSizeC
function HotLoot:ToggleSizeDisable()
	return disIconSizeC;
end
function HotLoot:ColorHide()
	if HotLoot:GetThemeSelect() == "color" then
		return false
	else
		return true
	end
end
-- color control
function MakeColor(key, input)
	if key == "ctrl" then
		return "|cFFFFCC00"..input.."|r"
	end
end

-- OnInitialize
function HotLoot:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("HotLootDB", hlDefaults, true)
	--s
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HotLoot", hlOptions)
    --self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HotLoot", "HotLoot")
	hIcon:Register("HotLoot", hLDB, hlDefaults.char)
    self:RegisterChatCommand("hl", "ChatCommand")
    self:RegisterChatCommand("hotloot", "ChatCommand")
	HotLoot:createMainFrame()
	
end


-- OnEnable
function HotLoot:OnEnable()
	if not HotLoot:GetThemeSelect() then
		HotLoot:SetThemeSelect(self,"classic")
	end
	
	tStart = 0;
	HotLoot:ToggleAnchor(HotLoot:GetLootShowAnchor());
	LoadThemeInit(HotLoot:GetThemeSelect());
	HotLoot:RegisterEvent("LOOT_OPENED")
	HotLoot:RegisterEvent("LOOT_CLOSED")
	HotLoot:RegisterEvent("LOOT_SLOT_CLEARED")
	HotLoot:RegisterEvent("BAG_UPDATE")
	
end

-- ChatCommand
function HotLoot:ChatCommand(input)
    if not input or input:trim() == "" then
        --InterfaceOptionsFrame_OpenToCategory(self.optionsFrame);
		--InterfaceOptionsFrame_OpenToCategory(self.optionsFrame);
		LibStub("AceConfigDialog-3.0"):Open("HotLoot")
	elseif input == "help" then
		print("|cFFCD6600HotLoot|r: Available Commands");
		print("|cFFCD6600HotLoot|r: |cFFFFCC00enable:|r     Enables/disables |cFFCD6600HotLoot|r");
		print("|cFFCD6600HotLoot|r: |cFFFFCC00debug:|r     Enables/disables debug mode");
		print("|cFFCD6600HotLoot|r: |cFFFFCC00autoclose:|r Toggles the autoclose option");
		print("|cFFCD6600HotLoot|r: |cFFFFCC00skinning:|r   Toggles skinning mode");
		print("|cFFCD6600HotLoot|r: |cFFFFCC00monitor:|r    Toggles loot monitor");
    else
        LibStub("AceConfigCmd-3.0"):HandleCommand("hl", "HotLoot", input);
    end
end

-- debug mode
function dBug(name, value)
	if (HotLoot:GetLootDebug() == true) then
		print("<HotLoot Debug> " .. tostring(name) .. " = " .. tostring(value));
	end
end
-- TestMonitor
function HotLoot:TestMonitor()
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(6948);
	local itoadd = HotLoot:addLootIcon(itemTexture, itemName, itemLink, 5);
	table.insert(icons, 1, itoadd);
	tStart = GetTime();
	itoadd = nil;
	itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = nil;			
	HotLoot:UpdateMonitor();
end
--==========================
--			GET ID
--==========================
local function GetItemID(itemLink)
	local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink,
		"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
	return tonumber(Id);
end
--==========================
--		IS KEY DOWN
--==========================
local function CloseKeyDown()
	local keyDown
	local modKey = HotLoot:GetLootCloseKey()
	if (modKey == "ctrl") then 
		keyDown = IsControlKeyDown()
	elseif (modKey == "shift") then 
		keyDown = IsShiftKeyDown()
	elseif (modKey == "alt") then 
		keyDown = IsAltKeyDown()
	end
	--dBug("keyDown",keyDown)
	return keyDown
end
local function SkinKeyDown()
	local sKeyDown
	local modKey = HotLoot:GetLootSkinKey()
	if (modKey == "ctrl") then 
		sKeyDown = IsControlKeyDown()
	elseif (modKey == "shift") then 
		sKeyDown = IsShiftKeyDown()
	elseif (modKey == "alt") then 
		sKeyDown = IsAltKeyDown()
	end
	return sKeyDown
end
--==========================
-- add to i list
--==========================
function AddIList(value)
	if GetItemInfo(value) then
		local iName = select(1,GetItemInfo(value))
		HotLoot:SetIncludeTable(iName)
	else
		HotLoot:SetIncludeTable(value)
	end
end
function RemoveIList()
	HotLoot:GetIncludeTable()[HotLoot:GetIncludeDrop()] = nil
end

--==========================
-- add to e list
--==========================
function AddEList(value)
	if GetItemInfo(tostring(value)) then
		local iName = select(1,GetItemInfo(value))
		HotLoot:SetExcludeTable(iName)
	else
		HotLoot:SetExcludeTable(value)
	end
end
function RemoveEList()
	HotLoot:GetExcludeTable()[HotLoot:GetExcludeDrop()] = nil
end
--==========================
-- to skin mode
--==========================
local function ToSkin(slot)
	local lootIcon, lootName, lootQuantity, lootQuality, locked = GetLootSlotInfo(slot)
	--dBug("lootName", lootName)
	--dBug("lootQuantity", lootQuantity)
	if  (HotLoot:GetLootSkinMode() or SkinKeyDown()) and (lootQuantity > 0) then
		lItems = lItems .. " " .. lootName
		--lItems[curSlot] = itemLink
		LootSlot(slot)
		dBug(lootName, "added to lItems")
		trigger = 1
		--dBug("trigger", trigger)
	end
end
--#############################
--		Skinning Mode
--#############################
function DeleteLeftovers()
	if (HotLoot:GetLootSkinMode() == true) or (trigger == 1) then
		trigger = 0;
		Announce(L["SkinAnnounce"]);
		--dBug("lItems", lItems);
		for b = 0, 4 do 
			for s = 1, GetContainerNumSlots(b) do 
				local dLink = GetContainerItemLink(b, s);
				--dBug("dLink", dLink);
				if dLink then
					local dName = select(1, GetItemInfo(dLink));
					--dBug(lItems, dName);
					--dBug("string.find", string.find(lItems, dName));
				--for i = 1, #lItems do
					if string.find(lItems, dName) ~= nil then 
						PickupContainerItem(b, s);
						if CursorHasItem() then
							Announce(dLink .. L["SkinAnnounce2"]);
							DeleteCursorItem();
						end
					end
				end
			end
		end
		lItems = " ";
	end
end
--==========================
--	Is it Gold or Currency
--==========================
local function IsGold(slot)
	if GetLootSlotType(slot) == 2 and HotLoot:GetLootGold() then 
		return true
	end
end
local function IsCurrency(slot)
	if GetLootSlotType(slot) == 3 and HotLoot:GetLootCurrency() then 
		return true
	end
end
--==========================
--		Total in Bags
--==========================
local function InBags(iName, lquant)
	local q, inBags, n, scount
	inBags = lquant;
	for b = 0, 4 do 
		for s = 1, GetContainerNumSlots(b) do 
			if GetContainerItemID(b, s) then
			n = select(1, GetItemInfo(GetContainerItemID(b, s)))
			if n == iName then
				q = select(2, GetContainerItemInfo(b, s))
				inBags = inBags + q
			end
			end
		end
	end
	return inBags
end
--==========================
--		CHECK FOR ROOM
--==========================
function HasRoom(room)
	local numFSlots = 0
	for b = 0, 4 do 
		numFSlots = numFSlots + select(1, GetContainerNumFreeSlots(b))
	end
	if  numFSlots >= room then
		return true
	else
		return false
	end
end
--==========================
--		CHECK STACKABLE
--==========================
function CanStack(iname, scount, lquant)
	local q, stackRoom, n
	stackRoom = 0;
	for b = 0, 4 do 
		for s = 1, GetContainerNumSlots(b) do 
			n = select(1, GetItemInfo(GetContainerItemID(b, s)))
			if n == iname then
				q = select(2, GetContainerItemInfo(b, s))
				stackRoom = (stackRoom) + (scount - q)
			end
		end
	end
	if lquant <= stackRoom then
		return true;	
	else
		return false;
	end
end
-- *****************CheckTreshold************
function CheckThreshold(iType, sellAmount, lootQuant)
	local value, quant;
	quant = lootQuant;
	if HotLoot:GetUseQuant() then
		value = quant * sellAmount;
	else
		value = sellAmount;
	end
	
	if HotLoot:GetType1() == iType then
		if tonumber(ToCopper(HotLoot:GetValue1())) <= value then
			return true
		else
			return false
		end
	elseif HotLoot:GetType2() == iType then
		if tonumber(ToCopper(HotLoot:GetValue2())) <= value then
			return true
		else
			return false
		end
	elseif HotLoot:GetType3() == iType then
		if tonumber(ToCopper(HotLoot:GetValue3())) <= value then
			return true
		else
			return false
		end
	else
		return true
	end
end
--**************thresh validator*******************
function round(num, idp)
    local mult = 10^(idp or 0)
    if num >= 0 then return math.floor(num * mult + 0.5) / mult
    else return math.ceil(num * mult - 0.5) / mult end
end
--##########SCANNER############


 
local function ScanTip(slot, name)
local hlTipScan = CreateFrame('GameTooltip', 'hlTipScan', UIParent, 'GameTooltipTemplate')
hlTipScan:SetOwner(UIParent, 'ANCHOR_NONE') 
	hlTipScan:SetLootItem(slot)
	local text = hlTipScanTextLeft2:GetText()
	text = hlTipScanTextLeft2:GetText()
	--dBug("scantip",text)
	if text == name then
		hlTipScan:Hide()
		return true
	else
		hlTipScan:Hide()
		return false
	end
	
end
--==========================
--			Filter
--==========================
local function ToFilters(slot)
	local lootIcon, lootName, lootQuantity, lootQuality, locked = GetLootSlotInfo(slot)
	local lootLink = GetLootSlotLink(slot)
	if HotLoot:GetExcludeTable()[lootName] then
		-- Don't Loot
		Announce(lootLink .. L["ExcludeAnnounce1"])
		return false
	end
	if IsGold(slot) then
		return true
	elseif IsCurrency(slot) then
		return true
	end
	local _, itemLink, _, _, _, itemType, itemSubType, itemStackCount, _, _, itemSellPrice = GetItemInfo(lootLink)
	if (HotLoot:GetLootDebug() == true) then
		print("---------------")
		print("Slot " .. slot .. ": " .. lootName)
		print("Item type: " .. itemType.."| Item sub type: " .. itemSubType)
	end
	if (HasRoom(1) or CanStack(lootName, itemStackCount, lootQuantity))--[[ and locked == 0 ]]then
			if
				-- Quest
				HotLoot:GetLootQuest() and (itemType == L["Quest"] or ScanTip(slot, L["Quest Item"])) and CheckThreshold("Quest", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Junk
				(itemSubType == L["Junk"]) and HotLoot:GetLootJunk() and CheckThreshold("Junk", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Cloth
				(itemSubType == L["Cloth"]) and (itemType == L["Trade Goods"]) and HotLoot:GetLootCloth() and CheckThreshold("Cloth", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Mining
				(itemSubType == L["Metal & Stone"]) and HotLoot:GetLootMining() and CheckThreshold("Metal & Stone", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Gems
				(itemType == L["Gem"]) and HotLoot:GetLootGems() and CheckThreshold("Gem", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Herbs
				(itemSubType == L["Herb"]) and HotLoot:GetLootHerbs() and CheckThreshold("Herb", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Leather
				(itemSubType == L["Leather"]) and (itemType == L["Trade Goods"]) and HotLoot:GetLootSkinning() and CheckThreshold("Leather", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Fishing (-junk)
				IsFishingLoot() and HotLoot:GetLootFishing() and (itemSubType ~= L["Junk"]) then 
					return true
			elseif
				-- enchanting
				HotLoot:GetLootEnchanting() and (itemSubType == L["Enchanting"]) and CheckThreshold("Enchanting", itemSellPrice, lootQuantity) then 
					return true
			
			elseif
				-- GetLootCooking
				HotLoot:GetLootCooking() and (itemSubType == L["Cooking"]) and CheckThreshold("Cooking Ingredient", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- GetLootRecipes
				HotLoot:GetLootRecipes() and (itemType == L["Recipe"]) then 
					return true
			elseif
				-- Pots
				(itemSubType == L["Potion"]) and HotLoot:GetLootPots() and CheckThreshold("Potion", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Flasks
				(itemSubType == L["Flask"]) and HotLoot:GetLootFlasks() and CheckThreshold("Flask", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Elixirs
				(itemSubType == L["Elixir"]) and HotLoot:GetLootElixirs() and CheckThreshold("Elixir", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- Motes
				(itemSubType == L["Elemental"]) and HotLoot:GetLootElemental() and CheckThreshold("Elemental", itemSellPrice, lootQuantity) then 
					return true
			elseif
				-- MoH
				(itemID == 89112) and (HotLoot:GetLootMoH() == true) then 
					return true	
			elseif
				--lootBotA
				(itemID == 103642) and (HotLoot:GetLootBotA() == true) then 
					return true	
			elseif
				--lootDoEM
				(itemID == 103643) and (HotLoot:GetLootDoEM() == true) then 
					return true	
			elseif
				--lootSC
				(itemID == 103641) and (HotLoot:GetLootSC() == true) then 
					return true
			elseif
				--lootRepMeat
				(itemID == 104265) and (HotLoot:GetLootRepMeat() == true) then 
					return true
			elseif
				--lootRepMeat
				(itemID == 104266) and (HotLoot:GetLootRepMeat() == true) then 
					return true
			elseif
				--lootRepMeat
				(itemID == 104264) and (HotLoot:GetLootRepMeat() == true) then 
					return true
			elseif
				--lootRepMeat
				(itemID == 104257) and (HotLoot:GetLootRepMeat() == true) then 
					return true
			elseif
				--lootRepMeat
				(itemID == 104267) and (HotLoot:GetLootRepMeat() == true) then 
					return true
			elseif
				-- Include List
				HotLoot:GetIncludeTable()[lootName] then 
					return true
			elseif
				-- Poor
				(HotLoot:GetLootPoor() == true) and (lootQuality == 0) and (CheckThreshold("z1Poor", itemSellPrice, lootQuantity)) then 
					return true
			elseif
				-- Common
				(HotLoot:GetLootCommon() == true) and (lootQuality == 1) and (CheckThreshold("z2Common", itemSellPrice, lootQuantity)) then 
					return true
			elseif
				-- Uncommon
				(IsInGroup() == false) and (HotLoot:GetLootUncommon() == true) and (lootQuality == 2) and (CheckThreshold("z3Uncommon", itemSellPrice, lootQuantity)) then 
					return true
			elseif
				-- Rare
				(IsInGroup() == false) and (HotLoot:GetLootRare() == true) and (lootQuality == 3) and (CheckThreshold("z4Rare", itemSellPrice, lootQuantity)) then 
					return true
			elseif
				-- Epic
				(IsInGroup() == false) and (HotLoot:GetLootEpic() == true) and (lootQuality == 4) and (CheckThreshold("z5Epic", itemSellPrice, lootQuantity)) then 
					return true
			elseif
				-- Legendary
				(IsInGroup() == false) and (HotLoot:GetLootLegendary() == true) and (lootQuality == 5) and (CheckThreshold("z6Legendary", itemSellPrice, lootQuantity)) then 
					return true
			end
			
			
	else
		Announce(L["BagsFull"])
		return false
	end
end


--#############################
--			Anchor
--#############################
function HotLoot:ToggleAnchor(val)
	if val then
		HotLoot:ShowAnchor()
	else
		HotLoot:HideAnchor()
	end
end

function HotLoot:ShowAnchor()
	HotLoot.mainFrame:SetAlpha(1)
end

function HotLoot:HideAnchor()
	HotLoot.mainFrame:SetAlpha(0)
end

--#############################
--		Monitor Refresh
--#############################
function HotLoot:UpdateMonitor()
	local i = 1;
	local yOffset;
	local xOffset;
	local row, column = 0, 0;
	if (HotLoot:GetLootGridMode() == true) and (HotLoot:GetLootShowNames() == false) then
		while i <= #icons do
			
			xOffset = column * HotLoot:GetLootIconSize(); --0, 32, 64, 96
			yOffset = ((row + 1) * (HotLoot:GetLootIconSize() * HotLoot:GetLootGrowthDirection())); --0, 0, 0, 0, 
			icons[i]:SetPoint("CENTER", HotLoot.mainFrame, "CENTER", xOffset, yOffset+5);
			i = i + 1;
			if column < (HotLoot:GetLootGridNumColumns() - 1) then
				column = column + 1;
			else 
				row = row + 1;
				column = 0;
			end
		end
	else
		while i <= #icons do
			yOffset = (i * ((HotLoot:GetLootIconSize() + 3) * HotLoot:GetLootGrowthDirection()));
			icons[i]:SetPoint("CENTER", HotLoot.mainFrame, "CENTER", 0, yOffset);
			i = i + 1;
		end
	end	
end
--#############################
--			Tooltips
--#############################



function ClearTooltips()
	GameTooltip:Hide();
	--HotLoot:UpdateMonitor();
end

function ShowTooltip(self)
	if self.item then
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
		GameTooltip:SetHyperlink(self.item);
		GameTooltip:Show();
	end
end

function OnEnter(self)
	mouse_focus = self;
	--GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
	--GameTooltip:SetHyperlink(self.item);
	self:ShowTooltip();
end

function OnLeave(self)
	mouse_focus = nil;
	--[[
	if self._highlights then
		self.icon_frame:HideHighlight();
	end
	]]
	--GameTooltip:Hide();
	--GameTooltip:ClearLines();
	ClearTooltips();
	ResetCursor();
end

--#############################
--		Loot Monitor Icon
--#############################
function HotLoot:addLootIcon(iPath, iName, iLink, iCount)
	--local xslot = #icons;
	--local yOffset = xslot * -32;
	local icon = self.createLootIcon(iPath, iName, iLink, iCount)
	--icon:SetParent
	icon:Show();
	
	return icon;
end
--HotLoot.itemNNN = nil;
function HotLoot.createLootIcon(iPath, iName, iLink, iCount)
	local frame = CreateFrame("Frame", iName);
	local iconBG = CreateFrame("frame", "bgtest", frame);
	local size = HotLoot:GetLootIconSize();
	frame:SetFrameStrata("BACKGROUND");
	frame:SetWidth(size);
	frame:SetHeight(size);
	--frame:EnableMouse(true);
	
	--frame:SetPoint("CENTER", HotLoot.mainFrame, "CENTER", 0, yOffset);
	if HotLoot:GetLootTrans() then
		frame:SetAlpha(HotLoot:GetLootTrans());
	else
		HotLoot:SetLootTrans(nil, 1)
	end
	if iCount > 0 then
		frame:SetScript("OnEnter", OnEnter);
		frame:SetScript("OnLeave", OnLeave);
		iconBG:SetScript("OnEnter", OnEnter);
		iconBG:SetScript("OnLeave", OnLeave);
	end
		
	local icon = frame:CreateTexture(iName.."Icon","OVERLAY");
	icon:SetSize(size,size);
	icon:SetPoint("CENTER",-2,0)
	icon:SetTexture(iPath);
	icon:SetTexCoord(0.07,0.93,0.07,0.93);
	--icon:SetAllPoints(frame);
	local count = frame:CreateFontString(nil, "OVERLAY");
	count:SetPoint("CENTER", frame, "CENTER", 2, 0);
	count:SetFont(STANDARD_TEXT_FONT, 11, "OUTLINE");
	--count:SetText("x"..iCount);
	local name = frame:CreateFontString(nil, "OVERLAY");
	--name:SetWidth(129);
	name:SetHeight(16);

	if HotLoot:GetTextSide() == 0 then
		name:SetPoint("LEFT", iconBG, "LEFT", size+2, 0);
		name:SetJustifyH("LEFT");
	else
		name:SetPoint("RIGHT", iconBG, "RIGHT", -1*(size+2), 0);
		name:SetJustifyH("RIGHT");
	end
	name:SetFont(STANDARD_TEXT_FONT, 9, "OUTLINE");
	
	frame.texture = icon;
	frame.item = iLink;
	frame.ShowTooltip = ShowTooltip;
	iconBG.item = iLink;
	iconBG.ShowTooltip = ShowTooltip;
	if HotLoot:GetLootShowNames() == true then
		if iCount == 0 then
			name:SetText(iName);
		else
			name:SetText(iLink);
		end
	end
	--local iconBG = frame:CreateTexture(nil, "BORDER");
	
	iconBG:SetBackdrop({bgFile = bgFileC, 
		edgeFile = edgeFileC, 
		tile = tileC, tileSize = tileSizeC, edgeSize = edgeSizeC, 
		insets = insetsC})
	
	iconBG:SetFrameLevel(0)
	--frame:SetFrameLevel(4)
	local r, g, b, a = HotLoot:GetThemeColorSelect()
	local br, bg, bb, ba = HotLoot:GetThemeColorBorderSelect()
	if HotLoot:GetColorQual() and iCount > 0 then
		local quality = select(3, GetItemInfo(iLink))
		if quality then
			br, bg, bb = GetItemQualityColor(quality)
		end
		iconBG:SetBackdropColor(r, g, b, a)
		iconBG:SetBackdropBorderColor(br, bg, bb, 1)
	else
		iconBG:SetBackdropColor(r, g, b, a)
		iconBG:SetBackdropBorderColor(br, bg, bb, ba)
	end
	iconBG:Show()
	
	if true then
		if HotLoot:GetTextSide() == 0 then
			iconBG:SetPoint("LEFT",frame,"LEFT",0,0	);
		else
			iconBG:SetPoint("RIGHT",frame,"RIGHT",0,0);
		end
		--iconBG:SetTexture("Interface\\AddOns\\HotLoot\\Themes\\"..srcC);
	end	
	--local inBags = InBags(iName)
	if HotLoot:GetLootShowQuantities() == true then
		if iCount > 0 then
			if HotLoot:GetShowTotal() then
				local inBags = InBags(iName, iCount)
				--inBags = inBags  + iCount
				count:SetText("x"..iCount.." ["..inBags.."]")
				--count:SetSize(count:GetStringWidth(),18)
			else
				count:SetText("x"..iCount)
				--count:SetSize(count:GetStringWidth(),18)
			end
		end
		--dBug("count-Width", count:GetStringWidth())
		--dBug("name-Width", name:GetStringWidth())
		local bgWidth = name:GetStringWidth() + count:GetStringWidth() + size +6
		bgWidth = max(bgWidth, tonumber(HotLoot:GetMinWidth()))
		iconBG:SetSize(bgWidth,heightC)
		if HotLoot:GetInlineQuant() then
			if HotLoot:GetTextSide() == 0 then
				count:SetPoint("RIGHT", iconBG, "RIGHT", -2, 0);
				--name:SetWidth(bgWidth-count:GetStringWidth()+4);
				--name:SetWidth(120);
			else
				count:SetJustifyH("LEFT")
				count:SetPoint("LEFT", iconBG, "LEFT", 2, 0);
				--name:SetWidth(bgWidth-count:GetStringWidth()+4);
			end
		end	
		--[[
		iconBG:SetSize(name:GetStringWidth()+count:GetStringWidth(),18)
		if HotLoot:GetInlineQuant() then
			if HotLoot:GetTextSide() == 0 then
				count:SetPoint("RIGHT", iconBG, "RIGHT", -2, 0);
				name:SetWidth(134-count:GetStringWidth());
				--name:SetWidth(120);
			else
				count:SetJustifyH("LEFT")
				count:SetPoint("LEFT", iconBG, "LEFT", 2, 0);
				name:SetWidth(name:GetStringWidth()-count:GetStringWidth()-4);
			end
		end		
		]]
	else
		local bgWidth = name:GetStringWidth() + size +6
		bgWidth = max(bgWidth, 135)
		iconBG:SetSize(bgWidth,heightC)
	end
	
	return frame;
end
--#############################
--			Fade Items
--#############################
local isFirst;
isFirst = 0;
function FadeItems()
	--====================
	-- 	   ElvUI Fix
	--====================
	if closeEL == 1 and _G["ElvLootFrame"] then
		_G["ElvLootFrame"]:Hide();
		closeEL = 0;
	end
	--====================
	-- Main Fade Section
	--====================
	local iframe, alpha, fDelay, iDelay, sDelay, fSpeed;
	iDelay = HotLoot:GetIDelay();
	sDelay = HotLoot:GetSDelay();
	fSpeed = HotLoot:GetFSpeed() * 0.01;
	if (isFirst == 0) then
		--isFirst = 0;
		fDelay = iDelay; -- 5
	else
		fDelay = sDelay; -- 1
	end
	if (icons[#icons] == nil) then
		isFirst = 0;
	end
	if (icons[#icons] ~= nil) and (tStart < (GetTime() - fDelay)) then
		iframe = icons[#icons];
		alpha = iframe:GetAlpha();
		if (alpha > 0) then 
			iframe:SetAlpha(alpha - fSpeed); -- fSpeed = 0.05
		elseif (alpha <= 0) then 
			iframe:Hide();
			table.remove(icons);
			--dBug("#icons", #icons);
			tStart = GetTime();
			isFirst = isFirst + 1;
			--dBug("isFirst", isFirst);
			--dBug("fDelay", fDelay);
		end
	end
end
--==========================
--			EVENTS
--==========================
function HotLoot:LOOT_OPENED()
	-- Create virtual loot window
	if HotLoot:GetLootEnabled() then
	mFocus = GetMouseFocus():GetName()
	trigger = 0
	numLoot = GetNumLootItems()
	for i=1, numLoot do
		--table.insert(vLoot, i, GetItemID(GetLootSlotLink(i)))
		if ToFilters(i) then
			--lootedByHL[i] = true
			--isLooted = true
			dBug("Looted: true")
			if (HotLoot:GetLootEnableMonitor() == true) then
				local lootIcon, lootName, lootQuantity, lootQuality, locked = GetLootSlotInfo(i)
				local itemLink = GetLootSlotLink(i)
				if IsGold(i) then
					lootName = GetCoinTextureString(ToCopper(lootName))
				end
				local itoadd = HotLoot:addLootIcon(lootIcon, lootName, itemLink, lootQuantity)
				table.insert(icons, 1, itoadd)
				tStart = GetTime()
				itoadd = nil
			
				HotLoot:UpdateMonitor()
			end
			LootSlot(i)
		else
			dBug("Looted: false")
			ToSkin(i)
		end
		
	end
	--dBug("lootedByHL",unpack(lootedByHL))
	if mFocus == nil then
			mFocus = "nil";
			end
			--dBug("mFocus", mFocus)
			if HotLoot:GetLootClose() and not CloseKeyDown() and string.find(mFocus, "WorldFrame") then
				
				closeEL = 1;
				CloseLoot();
		end
	end
end

function HotLoot:LOOT_CLOSED()
	--dBug("222222","%%%%%%%%");
	
	if trigger == 1 then
		--dBug("222222","%%%%%%%%");
		DeleteLeftovers();
	end
end
-- move icons to top \/   \/

function HotLoot:LOOT_SLOT_CLEARED()
	
end

function HotLoot:BAG_UPDATE(...)
	--dBug("222222","%%%%%%%%");
	--[[
	if trigger == 1 then
		--dBug("222222","%%%%%%%%");
		DeleteLeftovers();
	end]]--
end